﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;
using System.Collections;
using System.IO;

namespace ArrayFileAndExceptionHandlingExample
{
    //Create a person class with basic properies and method
    public class Person
    {
        public int iAge; //property
        private string strName;
        public string GetName() //method
        {
            return strName;
        }
        public void SetName(string Name)
        {
            strName = Name;
        }
        public virtual void Play() //virtual function
        {
            System.Console.WriteLine("I plays Nothing");
        }
    };
    class ArrayFileAndExceptionHandling
    {
        [DllImport("msvcrt")]
        static extern int _getch();
        static void Main(string[] args)
        {
            //Create a person Array
            Person[] PersonArray = new Person[3]; //create an array of 3 person
            PersonArray[0] = new Person(); //create the person 1 
            PersonArray[0].SetName("Jerry"); //set the name
            PersonArray[1] = new Person();
            PersonArray[1].SetName("Thomas");
            PersonArray[2] = new Person();
            PersonArray[2].SetName("Jiss");
            System.Console.WriteLine("Using Arrays");

            //iterate through each element in the array using the foreeach loop
            foreach (Person i in PersonArray)
            {
                System.Console.WriteLine(i.GetName());
            }

           
            ArrayList PersonsList = new ArrayList();
            Person Person1 = new Person();
            Person1.SetName("Sachin");
            PersonsList.Add(Person1);
            Person Person2 = new Person();
            Person2.SetName("Rahul");
            PersonsList.Add(Person2);
            System.Console.WriteLine("Using Arraylist");
            foreach (Person List in PersonsList)
            {
                System.Console.WriteLine(List.GetName());
            }
           //save these details to a file
            try //Exception handler
            {
                System.Console.WriteLine("Saving the details to the file");
                using (FileStream fs = File.Create("PersonDetails.txt")) // creating the file with the specified name
                {

                    foreach (Person List in PersonsList)
                    {
                        byte[] bValues = new UTF8Encoding(true).GetBytes(List.GetName());//Extracting the bytes

                        fs.Write(bValues, 0, bValues.Length);//writing the contents to the file
                    }

                }

            }
            catch (Exception ex) //block
            {
                System.Console.WriteLine("some error occour while saving:"+ ex.Message);
               

            }
            

            _getch();
        }
    }
}
